#include <stdio.h>
#include <termio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ioctl.h>



/*------------------------------------------------------------
 * The main routine.
 */


main(argc, argv)
    int argc;
    char **argv;
{
    struct termio console, oconsole;


	if ( ioctl(0,TCGETA,&oconsole) < 0 ) {
	   perror("PANIC cannot TCGETA console");
	   exit(1);
	}

	console.c_iflag = IGNBRK ;
	console.c_oflag = NULL ;
	console.c_cflag = B9600 | CS8 | CREAD ;
	console.c_lflag = NULL ;
	console.c_line  = NULL ;
	console.c_cc[VEOF] = 1;
	console.c_cc[VEOL] = 0;
	
	if ( ioctl(0,TCSETA,&console) < 0 ) {
	   perror("PANIC cannot TCSETA console");
	   exit(1);
	}

	if (1) {
	   char chb[2];

	   while(read(0, chb, 1) == 1) {
	      if (*chb == 3) break;
	      write(0, chb, 1);
	   }

	   if ( ioctl(0,TCSETAW,&oconsole) < 0 ) {
	      perror("PANIC cannot TCSETAW console");
	   }

	   write(1, "\r\n", 2);
	}

	exit(0);
}
