#include <stdio.h>
#include <fcntl.h>
#include <errno.h>

extern int errno;

#define L_SET 0
#define BSIZE 32
char buffer[BSIZE];

main()
{
    int mem = open("/dev/mem", O_RDWR, 0);

    if (mem < 0) {
	if (errno == EPERM) {
	    fprintf(stderr,
		    "Sorry man, you must have read&write access to /dev/mem\n");
	} else {
	    perror("Sorry, Can't open /dev/mem");
	}
	exit(1);
    }

    {
	int lines = 1024;
	long source = 0x100000 + 96;
	long dest = 0x100000 + 64;
	do {
	    fprintf(stderr, "\r%6d s", lines); fflush(stderr);
	    lseek(mem, source, L_SET);
	    write(2, "r", 1);
	    read(mem, buffer, BSIZE);
	    write(2, "s", 1);
	    lseek(mem, dest, L_SET);
	    write(2, "w", 1);
	    write(mem, buffer, BSIZE);
	    write(2, "\r            \r", 12);
	    source += 128;
	    dest += 128;
	} while (--lines > 0);
    }

    exit(0);
}

